/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by applyconfiguration-gen. DO NOT EDIT.

package v1alpha3

import (
	v1 "sigs.k8s.io/gateway-api/apis/v1"
	apisv1alpha3 "sigs.k8s.io/gateway-api/apis/v1alpha3"
)

// SubjectAltNameApplyConfiguration represents a declarative configuration of the SubjectAltName type for use
// with apply.
type SubjectAltNameApplyConfiguration struct {
	Type     *apisv1alpha3.SubjectAltNameType `json:"type,omitempty"`
	Hostname *v1.Hostname                     `json:"hostname,omitempty"`
	URI      *v1.AbsoluteURI                  `json:"uri,omitempty"`
}

// SubjectAltNameApplyConfiguration constructs a declarative configuration of the SubjectAltName type for use with
// apply.
func SubjectAltName() *SubjectAltNameApplyConfiguration {
	return &SubjectAltNameApplyConfiguration{}
}

// WithType sets the Type field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Type field is set to the value of the last call.
func (b *SubjectAltNameApplyConfiguration) WithType(value apisv1alpha3.SubjectAltNameType) *SubjectAltNameApplyConfiguration {
	b.Type = &value
	return b
}

// WithHostname sets the Hostname field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Hostname field is set to the value of the last call.
func (b *SubjectAltNameApplyConfiguration) WithHostname(value v1.Hostname) *SubjectAltNameApplyConfiguration {
	b.Hostname = &value
	return b
}

// WithURI sets the URI field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the URI field is set to the value of the last call.
func (b *SubjectAltNameApplyConfiguration) WithURI(value v1.AbsoluteURI) *SubjectAltNameApplyConfiguration {
	b.URI = &value
	return b
}
